'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ = require('./');

var _2 = _interopRequireDefault(_);

var _selectors = require('./selectors');

var _createButtonPressedEvent = require('./createButtonPressedEvent');

var _createButtonPressedEvent2 = _interopRequireDefault(_createButtonPressedEvent);

var _createCertainButtonPressedEvent = require('./createCertainButtonPressedEvent');

var _createCertainButtonPressedEvent2 = _interopRequireDefault(_createCertainButtonPressedEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const eventName = 'inlineButtonPressed';

const onCallbackQueryReceived = (bot, update, callbackQuery) => {
  bot.emit(eventName, (0, _createButtonPressedEvent2.default)(update, callbackQuery));

  const pressedInlineButtonId = (0, _selectors.getPressedInlineButtonId)(update);
  if (!pressedInlineButtonId) return;

  bot.emit(`${eventName}/${pressedInlineButtonId}`, (0, _createCertainButtonPressedEvent2.default)(update, callbackQuery, pressedInlineButtonId));
};

exports.default = onCallbackQueryReceived;